/* simple wall clock - display current time in big letters */

/* Version: $Id: clock.c,v 1.2 2001/06/27 04:13:29 als Exp $ */

/* Note: this code is NOT portable */


#include <stdio.h>
#include <conio.h>

#define ONCHAR 0xdb
#define OFFCHAR ' '

char font[11][8][16];

char fontblocks[11][16][9];


char i2c(i)
  int i;  {

  switch (i) {
    case 0 : return '0';
    case 1 : return '1';
    case 2 : return '2';
    case 3 : return '3';
    case 4 : return '4';
    case 5 : return '5';
    case 6 : return '6';
    case 7 : return '7';
    case 8 : return '8';
    case 9 : return '9';
    default : return '?';
  }

}

int c2i(c)
    char c; {

    switch (c) {
      case '0': return 0;
      case '1': return 1;
      case '2': return 2;
      case '3': return 3;
      case '4': return 4;
      case '5': return 5;
      case '6': return 6;
      case '7': return 7;
      case '8': return 8;
      case '9': return 9;
      case ':': return 10;   /* special case for time display */
      case '-': return 10;   /* special case for time display */
      default: return -1;
    }
}




void init_font() {

    unsigned short int x, y, n;

/* clear font bitmap */
    for ( n = 0; n < 11 ; n++ ) {
        for ( x = 0; x < 8; x++ ) {
            for ( y = 0; y < 16; y++ ) {
                font[n][x][y] = OFFCHAR;
            }
            font[n][x][16] = 0;
        }
    }


/* number 0 */
    for (x = 1; x < 7; x++ ) {
        font[0][x][1] = ONCHAR;
        font[0][x][14] = ONCHAR;
    }
    for ( y = 1; y < 15; y++) {
        font[0][1][y] = ONCHAR;
        font[0][6][y] = ONCHAR;
    }

/* number 1 */
    for ( y = 1; y < 15; y++ ) {
        font[1][6][y] = ONCHAR;
    }

/* number 2 */
    for ( x = 1; x < 7; x++ ) {
        font[2][x][1] = ONCHAR;
        font[2][x][7] = ONCHAR;
        font[2][x][14] = ONCHAR;
    }
    for ( y = 1; y < 7; y++ ) {
        font[2][6][y] = ONCHAR;
    }
    for ( y = 7; y < 14; y++ ) {
        font[2][1][y] = ONCHAR;
    }

/* number 3 */
    for ( y = 1; y < 15; y++ ) {
        font[3][6][y] = ONCHAR;
    }
    for ( x = 1; x < 7; x++ ) {
        font[3][x][1] = ONCHAR;
        font[3][x][7] = ONCHAR;
        font[3][x][14] = ONCHAR;
    }

/* number 4 */
    for ( y = 1; y < 15; y++ ) {
        font[4][6][y] = ONCHAR;
    }
    for ( y = 1; y < 7; y++ ) {
        font[4][1][y] = ONCHAR;
    }
    for ( x = 1; x < 7; x++ ) {
        font[4][x][7] = ONCHAR;
    }

/* number 5 */
    for ( x = 1; x < 7; x++ ) {
        font[5][x][1] = ONCHAR;
        font[5][x][7] = ONCHAR;
        font[5][x][14] = ONCHAR;
    }
    for ( y = 1; y < 7; y++ ) {
        font[5][1][y] = ONCHAR;
		font[5][6][y + 7] = ONCHAR;
    }

/* number 6 */
    for ( x = 1; x < 7; x++ ) {
        font[6][x][1] = ONCHAR;
        font[6][x][7] = ONCHAR;
        font[6][x][14] = ONCHAR;
    }
    for ( y = 1; y < 8; y++ ) {
        font[6][1][y] = ONCHAR;
        font[6][1][y + 7] = ONCHAR;
        font[6][6][y + 7] = ONCHAR;
    }

/* number 7 */
    for ( x = 1; x < 7; x++ ) {
        font[7][x][1] = ONCHAR;
    }
    for ( y = 1; y < 15; y++ ) {
        font[7][6][y] = ONCHAR;
    }

/* number 8 */
    for ( x = 1; x < 7; x++ ) {
        font[8][x][1] = ONCHAR;
        font[8][x][7] = ONCHAR;
        font[8][x][14] = ONCHAR;
    }
    for ( y = 1; y < 15; y++ ) {
        font[8][1][y] = ONCHAR;
        font[8][6][y] = ONCHAR;
    }

/* number 9 */
    for ( x = 1; x < 7; x++ ) {
        font[9][x][1] = ONCHAR;
        font[9][x][7] = ONCHAR;
        font[9][x][14] = ONCHAR;
    }
    for ( y = 1; y < 15; y++ ) {
        font[9][6][y] = ONCHAR;
    }
    for ( y = 1; y < 8; y++ ) {
        font[9][1][y] = ONCHAR;
    }


/* separator : */

    font[10][3][5] = ONCHAR;
    font[10][3][10] = ONCHAR;

    for ( n = 0; n < 11; n++ ) {
        for ( x = 0; x < 8; x++ ) {
            font[n][x][16] = 0;
        }
    }

}


void init_fontblocks () {


    int n, x, y;

    for ( n = 0; n < 11; n++ ) {
        for ( x = 0; x < 8; x++ ) {
            for (y = 0; y < 16; y++ ) {
                fontblocks[n][y][x] = font[n][x][y];
            }
            fontblocks[n][y][16] = 0;
        }
    }
}


